#include <hilbert/kernel/terminal.hpp>
#include <hilbert/kernel/panic.hpp>

namespace hilbert::kernel {
  [[noreturn]] void panic(const char *string_sz) {
    terminal::put_string_sz(string_sz);
    while (1)
      asm ("hlt");
  }
}
